/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.antrax.storage.commons.impl.AlarisSms.LongMessageMode;
import com.flamesgroup.antrax.storage.commons.impl.AlarisSms.Status;
import com.flamesgroup.storage.convert.AlarisSmsLongMessageModeConverter;
import com.flamesgroup.storage.convert.AlarisSmsStatusConverter;
import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.AlarisSmsRecord;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.UUID;

import org.jooq.Field;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class AlarisSms extends TableImpl<AlarisSmsRecord> {

	private static final long serialVersionUID = -978696812;

	/**
	 * The reference instance of <code>public.alaris_sms</code>
	 */
	public static final AlarisSms ALARIS_SMS = new AlarisSms();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<AlarisSmsRecord> getRecordType() {
		return AlarisSmsRecord.class;
	}

	/**
	 * The column <code>public.alaris_sms.id</code>.
	 */
	public final TableField<AlarisSmsRecord, UUID> ID = createField("id", org.jooq.impl.SQLDataType.UUID.nullable(false), this, "");

	/**
	 * The column <code>public.alaris_sms.ani</code>.
	 */
	public final TableField<AlarisSmsRecord, String> ANI = createField("ani", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.alaris_sms.dnis</code>.
	 */
	public final TableField<AlarisSmsRecord, String> DNIS = createField("dnis", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.alaris_sms.message</code>.
	 */
	public final TableField<AlarisSmsRecord, String> MESSAGE = createField("message", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.alaris_sms.service_type</code>.
	 */
	public final TableField<AlarisSmsRecord, String> SERVICE_TYPE = createField("service_type", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.alaris_sms.long_message_mode</code>.
	 */
	public final TableField<AlarisSmsRecord, LongMessageMode> LONG_MESSAGE_MODE = createField("long_message_mode", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new AlarisSmsLongMessageModeConverter());

	/**
	 * The column <code>public.alaris_sms.data_coding</code>.
	 */
	public final TableField<AlarisSmsRecord, Integer> DATA_CODING = createField("data_coding", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.alaris_sms.status</code>.
	 */
	public final TableField<AlarisSmsRecord, Status> STATUS = createField("status", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new AlarisSmsStatusConverter());

	/**
	 * The column <code>public.alaris_sms.create_time</code>.
	 */
	public final TableField<AlarisSmsRecord, Date> CREATE_TIME = createField("create_time", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaulted(true), this, "", new DateConverter());

	/**
	 * The column <code>public.alaris_sms.last_update_time</code>.
	 */
	public final TableField<AlarisSmsRecord, Date> LAST_UPDATE_TIME = createField("last_update_time", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaulted(true), this, "", new DateConverter());

	/**
	 * The column <code>public.alaris_sms.sar_id</code>.
	 */
	public final TableField<AlarisSmsRecord, String> SAR_ID = createField("sar_id", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.alaris_sms.sar_parts</code>.
	 */
	public final TableField<AlarisSmsRecord, Integer> SAR_PARTS = createField("sar_parts", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.alaris_sms.sar_part_number</code>.
	 */
	public final TableField<AlarisSmsRecord, Integer> SAR_PART_NUMBER = createField("sar_part_number", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.alaris_sms.sms_id</code>.
	 */
	public final TableField<AlarisSmsRecord, UUID> SMS_ID = createField("sms_id", org.jooq.impl.SQLDataType.UUID, this, "");

	/**
	 * The column <code>public.alaris_sms.client_ip</code>.
	 */
	public final TableField<AlarisSmsRecord, String> CLIENT_IP = createField("client_ip", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * Create a <code>public.alaris_sms</code> table reference
	 */
	public AlarisSms() {
		this("alaris_sms", null);
	}

	/**
	 * Create an aliased <code>public.alaris_sms</code> table reference
	 */
	public AlarisSms(String alias) {
		this(alias, ALARIS_SMS);
	}

	private AlarisSms(String alias, Table<AlarisSmsRecord> aliased) {
		this(alias, aliased, null);
	}

	private AlarisSms(String alias, Table<AlarisSmsRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<AlarisSmsRecord> getPrimaryKey() {
		return Keys.ALARIS_SMS_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<AlarisSmsRecord>> getKeys() {
		return Arrays.<UniqueKey<AlarisSmsRecord>>asList(Keys.ALARIS_SMS_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public AlarisSms as(String alias) {
		return new AlarisSms(alias, this);
	}

	/**
	 * Rename this table
	 */
	public AlarisSms rename(String name) {
		return new AlarisSms(name, null);
	}
}
